#include <QApplication>
#include <QQmlApplicationEngine>
#include <QQmlContext>
#include "../common/sources/Map.h"
#include "bridge.h"
#include "editor.h"
#include <QDebug>
#include <QQuickItem>
#include <QtQml/qqmlprivate.h>

QQmlContext     *ctxt;
QQmlApplicationEngine*  myQmlEngine;
QQuickItem*     tileSelGrid;
QQuickItem*     wallSelGrid;
QQuickItem*     objSelGrid;

int main(int argc, char *argv[])
{
    QApplication app(argc, argv);
    QQmlApplicationEngine engine;
    myQmlEngine = &engine;

    map.resize();

    // enregistre nos fonctions
    ctxt = engine.rootContext();
    editor.initLists();
    ctxt->setContextProperty("bridge", &bridge);
    ctxt->setContextProperty("tilesList", QVariant::fromValue(bridge.tilesList));
    ctxt->setContextProperty("wallsList", QVariant::fromValue(bridge.wallsList));
    ctxt->setContextProperty("ornatesList", QVariant::fromValue(bridge.ornatesList));

    // enregistre l'ImageProvider
    engine.addImageProvider("myimageprovider", new MyImageProvider);

    // lance l'interface
    engine.load(QUrl(QStringLiteral("qrc:/main.qml")));

    QObject *rootObject = engine.rootObjects().first();
    tileSelGrid = qobject_cast<QQuickItem*>(rootObject->findChild<QObject*>("tSelGrid"));
    wallSelGrid = qobject_cast<QQuickItem*>(rootObject->findChild<QObject*>("wSelGrid"));
    objSelGrid = qobject_cast<QQuickItem*>(rootObject->findChild<QObject*>("oSelGrid"));

    return app.exec();
}
